/***********************************************************************
 * Copyright (c)  2017 - 2022, Unicmicro Co.,Ltd .
 * All rights reserved.
 * Filename    : app.c
 * Description : app source file
 * Author(s)   : Mason
 * version     : V1.0
 * Modify date : 2022-08-04
 ***********************************************************************/
#include  "app.h"
#include  "config.h"
#include  "common.h"
#include  "uart0.h"
#include  "uart1.h"
#include  "uart2.h"
#include  "rtc.h"

uint32_t g_data_buf[512];

/*使用BCD码初始化万年历为：22年7月18日星期一11时30分0秒*/
s_calendar_obj calendar = {0x22, 0x07, 0x18, 0x01, 0x11, 0x30 ,0x00};

#ifdef UART0_COMM
uint8_t uart0_rx_flag = 0;
uint8_t uart0_rx_buf[64];
uint8_t uart0_rx_count = 0;
#endif

#ifdef UART1_COMM
uint8_t uart1_rx_flag = 0;
uint8_t uart1_rx_buf[64];
uint8_t uart1_rx_count = 0;
#endif

#ifdef UART2_COMM
uint8_t uart2_rx_flag = 0;
uint8_t uart2_rx_buf[64];
uint8_t uart2_rx_count = 0;
#endif

#ifdef UART0_COMM
/************************************************************************
 * Function     : uart0_rec_pro
 * Description  : uart0 rec pro 串口接收处理回调函数
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void uart0_rec_pro(void)
{
	uart0_rx_buf[uart0_rx_count] = uart0_recv_byte();
	uart0_rx_count++;
	uart0_rx_flag = 1;	
}
#endif

#ifdef UART1_COMM
/************************************************************************
 * Function     : uart1_rec_pro
 * Description  : uart1 rec pro 串口接收处理回调函数
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void uart1_rec_pro(void)
{
	uart1_rx_buf[uart1_rx_count] = uart1_recv_byte();
	uart1_rx_count++;
	uart1_rx_flag = 1;	
}
#endif

#ifdef UART2_COMM
/************************************************************************
 * Function     : uart2_rec_pro
 * Description  : uart2 rec pro 串口接收处理回调函数
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void uart2_rec_pro(void)
{
	uart2_rx_buf[uart2_rx_count] = uart2_recv_byte();
	uart2_rx_count++;
	uart2_rx_flag = 1;	
}
#endif

/************************************************************************
 * Function     : uart_init
 * Description  : uart_init 串口初始化
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void uart_init(void)
{
#ifdef  UART0_COMM     
	uart0_rx_flag = 0;
	uart0_init(PCLK, UART0_BAUD_RATE);
	uart0_irq_init(UART0_IRQ_ENABLE, uart0_rec_pro);
#endif

#ifdef  UART1_COMM	
	uart1_rx_flag = 0;	
	uart1_init(PCLK, UART1_BAUD_RATE);
	uart1_irq_init(UART1_IRQ_ENABLE, uart1_rec_pro);
#endif

#ifdef  UART2_COMM    
    uart2_rx_flag = 0;	
	uart2_init(PCLK, UART2_BAUD_RATE);
	uart2_irq_init(UART2_IRQ_ENABLE, uart2_rec_pro);
#endif
}

/************************************************************************
 * Function     : rtc_int_pro
 * Description  : rtc中断处理函数 
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void rtc_int_pro(void)
{
	rtc_calendar_get(&calendar.year, &calendar.month, &calendar.day, \
					&calendar.week, &calendar.hour, &calendar.min, \
					&calendar.sec); 	//获取万年历

	printfS("Year:%x , Month:%x , Day:%x , Week:%x, Hour: %x ,Minute: %x ,Second: %x , \n", \
			calendar.year, calendar.month, calendar.day, calendar.week, \
			calendar.hour, calendar.min, calendar.sec);
}

/************************************************************************
 * Function     : rtc_test
 * Description  : rtc test 
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void rtc_test(void)
{
	printfS("System run at %dHz\r\n", SystemCoreClock);
	printfS("start test rtc! \n");

	rtc_enable();	//使能RTC
	rtc_calendar_set(calendar.year, calendar.month, calendar.day, calendar.week, \
					calendar.hour, calendar.min, calendar.sec); //初始化万年历
	
	rtc_irq_init(RTC_IRQ_ENABLE, rtc_int_pro);  //开启RTC中断
	
	while(1)
	{
		
	}
}

/************************************************************************
 * Function     : soc_test
 * Description  : soc test 
 * Input        : none
 * Output		: none
 * Return       : none
 ************************************************************************/
void soc_test(void)
{
	rtc_test();  
 
}

